import std/[json, jsonutils, options, sequtils, strutils, times]
import db_connector/db_sqlite
import waterpark/sqlite
import fiber_orm, namespaced_logging, timeutils

import ./models

export fiber_orm.NotFoundError
export fiber_orm.PaginationParams
export fiber_orm.PagedRecords
export fiber_orm.enableDbLogging
export sqlite.close

type
  WdiwtltDb* = SqlitePool


func toJsonHook*(dt: DateTime): JsonNode = %(dt.formatIso8601)
proc fromJsonHook*(dt: var DateTime, n: JsonNode): void =
  dt = n.getStr.parseIso8601


proc initDB*(dbPath: string): SqlitePool =
  newSqlitePool(10, dbPath)

generateProcsForModels(WdiwtltDb,
  [Artist, Album, MediaFile, Tag, Playlist, Bookmark, Image])
